package SliMP3::Buttons::Games;

# SliMP3 Server Copyright (C) 2001 Sean Adams, Slim Devices Inc.
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License,
# version 2.

use strict;
use File::Spec::Functions qw(:ALL);
use File::Spec::Functions qw(updir);

use SliMP3::Buttons::Shooter;
use SliMP3::Buttons::SlimTris;
use SliMP3::Strings qw (string);

# button functions for top-level games directory
my @gamesChoices = ('SLIMTRIS', 'SHOOTER');

my %functions = (
	'up' => sub  {
		my $client = shift;
		my $newposition = SliMP3::Buttons::Common::scroll($client, -1, ($#gamesChoices + 1), $client->gamesSelection);
		$client->gamesSelection($newposition);
		SliMP3::Display::update($client);
	},
	'down' => sub  {
		my $client = shift;
		my $newposition = SliMP3::Buttons::Common::scroll($client, +1, ($#gamesChoices + 1), $client->gamesSelection);
		$client->gamesSelection($newposition);
		SliMP3::Display::update($client);
	},
	'left' => sub  {
		my $client = shift;
		SliMP3::Buttons::Common::popModeRight($client);
	},
	'right' => sub  {
		my $client = shift;
		my @oldlines = SliMP3::Display::curLines($client);
		if ($gamesChoices[$client->gamesSelection] eq 'SLIMTRIS') {
			SliMP3::Buttons::Common::pushMode($client, 'slimtris');
		} elsif ($gamesChoices[$client->gamesSelection] eq 'SHOOTER') {
			SliMP3::Buttons::Common::pushMode($client, 'shooter');
		}
		SliMP3::Animation::pushLeft($client, @oldlines, SliMP3::Display::curLines($client));
	},
	'numberScroll' => sub  {
		my $client = shift;
		my $button = shift;
		my $digit = shift;
		my $newpos;
		$client->gamesSelection(SliMP3::Buttons::Common::numberScroll($client, $digit, \@gamesChoices, 0));
		SliMP3::Display::update($client);
	}
);

sub getFunctions {
	return \%functions;
}

sub setMode {
	my $client = shift;
	$client->lines(\&lines);
}

#
# figure out the lines to be put up to display the directory
#
sub lines {
	my $client = shift;
	my ($line1, $line2);

	$line1 = string('GAMES');
	$line2 = string($gamesChoices[$client->gamesSelection]);

	return ($line1, $line2, undef, chr($SliMP3::VFD::RIGHTARROW));
}

1;

__END__
